#include "image.hpp"
#include "DxLib.h"

/*
  Image̔hNX̎
*/

class ColorImage : public Image
{
private:
	int width, height, color;
public:
	ColorImage(int width, int height, int color)
	: width(width), height(height), color(color)
	{}
	void Draw(int x, int y) {
		DrawBox(x, y, x+width, y+height, color, TRUE);
	}
};

std::shared_ptr<Image> MakeColorImage(int w, int h, int color)
{
	return std::make_shared<ColorImage>(w, h, color);
}

class GraphImage : public Image
{
private:
	int handle;
public:
	GraphImage(const char *filename) {
		handle = LoadGraph(filename);
	}
	void Draw(int x, int y) {
		DrawGraph(x, y, handle, TRUE);
	}
};

std::shared_ptr<Image> MakeGraphImage(const char *filename)
{
	return std::make_shared<GraphImage>(filename);
}
