#include "DxLib.h"
#include "image.hpp"
#include "tilemap.hpp"
#include <cstdint>
#include <memory>

int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	ChangeWindowMode(TRUE);
	if (DxLib_Init() != 0) return 0;
	SetDrawScreen(DX_SCREEN_BACK);

	/*
	  ^C}bvЂƂ
	*/
	// C[WXg
	TileImageList imglst20;
	imglst20.push_back(MakeColorImage(8, 8, GetColor(  0,  0,  0)));
	imglst20.push_back(MakeColorImage(8, 8, GetColor(128,192,255)));
	imglst20.push_back(MakeGraphImage("30.png"));
	// }bvf[^
	uint32_t mapdata20[8*8] = {
		0,0,1,0,0,0,0,0,
		0,0,0,1,0,0,0,1,
		0,0,1,1,1,1,1,1,
		0,1,1,0,1,2,1,0,
		1,1,1,1,1,1,1,1,
		1,0,1,1,1,1,1,1,
		1,0,1,0,0,0,0,0,
		0,0,0,1,1,0,1,1,
	};
	class TileIndexer20 : public TileIndexer
	{
		uint32_t *mapdata;
	public:
		TileIndexer20(uint32_t *mapdata)
		: mapdata(mapdata) {}
		int GetTileIndex(int x, int y) {
			return mapdata[y*GetMapWidth()+x];
		}
		int GetMapWidth() { return 8; }
		int GetMapHeight() { return 8; }
		int GetTileWidth() { return 8; }
		int GetTileHeight() { return 8; }
	} tileindexer20(mapdata20);
	Tilemap tilemap20(64, 64, tileindexer20, imglst20);
	/*
	  ^C}bv2
	*/
	// C[WXg
	TileImageList imglst10;
	imglst10.push_back(MakeColorImage(64, 64, GetColor(  0,  0,  0)));
	imglst10.push_back(MakeColorImage(64, 64, GetColor(255,128,192)));
	/* C[WXgɃ^C}bvo^ēq */
	imglst10.push_back(std::shared_ptr<Image>(new Tilemap(64, 64, tileindexer20, imglst20)));
	// }bvf[^
	struct mapdata10_t { /* f[^`͎R */
		int dummy;
		int tileidx;
	} mapdata10[10*8] = {
		{0,0},{0,0},{0,0},{0,0},{0,1},{0,1},{0,1},{0,1},{0,0},{0,0},
		{0,0},{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},
		{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},
		{0,1},{0,2},{0,1},{0,0},{0,0},{0,1},{0,1},{0,0},{0,0},{0,1},
		{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},{0,1},
		{0,0},{0,0},{0,0},{0,1},{0,1},{0,0},{0,0},{0,1},{0,1},{0,0},
		{0,0},{0,0},{0,1},{0,1},{0,0},{0,1},{0,1},{0,0},{0,1},{0,1},
		{0,1},{0,1},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,1},
	};
	class TileIndexer10 : public TileIndexer
	{
		mapdata10_t *mapdata;
	public:
		TileIndexer10(mapdata10_t *mapdata)
		: mapdata(mapdata) {}
		int GetTileIndex(int x, int y) {
			return mapdata[y*GetMapWidth()+x].tileidx;
		}
		int GetMapWidth() { return 10; }
		int GetMapHeight() { return 8; }
		int GetTileWidth() { return 64; }
		int GetTileHeight() { return 64; }
	} tileindexer10(mapdata10);
	// ^C}bv
	Tilemap tilemap10(512, 512, tileindexer10, imglst10);

	while (ProcessMessage() == 0 && ScreenFlip() == 0 && ClearDrawScreen() == 0) {
		tilemap10.Draw(0, 0);
	}
	
	DxLib_End();
	return 0;
}
