#include <vector>
#include <memory>

// C[WXg͂Ƃ肠̌`
typedef std::vector<std::shared_ptr<Image>> TileImageList;

class TileIndexer
{
public:
	virtual int GetTileIndex(int x, int y) = 0;
	virtual int GetMapWidth() = 0;
	virtual int GetMapHeight() = 0;

	// ̃Tvł͓KȏꏊȂ̂
	// ^C̑傫擾郁\bhƂ肠ɔzu
	virtual int GetTileWidth() = 0;
	virtual int GetTileHeight() = 0;
};

class Tilemap : public Image
{
private:
	TileIndexer &idxr;
	TileImageList &imglst;
public:
	Tilemap(int w, int h, TileIndexer &idxr, TileImageList &imglst)
	: idxr(idxr), imglst(imglst) {}
	void Draw(int x, int y) {
		int mw = idxr.GetMapWidth();
		int mh = idxr.GetMapHeight();
		int tx = x, ty = y;
		for (int i=0; i<mh; i++) {
			for (int j=0; j<mw; j++) {
				imglst[idxr.GetTileIndex(j, i)]->Draw(tx, ty);
				tx += idxr.GetTileWidth();
			}
			ty += idxr.GetTileHeight();
			tx = x;
		}
	}
};

